Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_sw.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_sw.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_sw.F90	(revision 4853)
@@ -74,12 +74,11 @@
     ! Gas and aerosol optical depth, single-scattering albedo and
     ! asymmetry factor at each shortwave g-point
-!    real(jprb), intent(in), dimension(istartcol:iendcol,nlev,config%n_g_sw) :: &
-    real(jprb), intent(in), dimension(config%n_g_sw,nlev,istartcol:iendcol) :: &
-         &  od, ssa, g
+    real(jprb), intent(in), dimension(config%n_g_sw,nlev,istartcol:iendcol) &
+         &  :: od, ssa, g
 
     ! Cloud and precipitation optical depth, single-scattering albedo and
     ! asymmetry factor in each shortwave band
-    real(jprb), intent(in), dimension(config%n_bands_sw,nlev,istartcol:iendcol) :: &
-         &  od_cloud, ssa_cloud, g_cloud
+    real(jprb), intent(in), dimension(config%n_bands_sw,nlev,istartcol:iendcol) &
+         &  :: od_cloud, ssa_cloud, g_cloud
 
     ! Optical depth, single scattering albedo and asymmetry factor in
@@ -92,6 +91,6 @@
     ! flux into a plane perpendicular to the incoming radiation at
     ! top-of-atmosphere in each of the shortwave g points
-    real(jprb), intent(in), dimension(config%n_g_sw,istartcol:iendcol) :: &
-         &  albedo_direct, albedo_diffuse, incoming_sw
+    real(jprb), intent(in), dimension(config%n_g_sw,istartcol:iendcol) &
+         &  :: albedo_direct, albedo_diffuse, incoming_sw
 
     ! Output
@@ -166,4 +165,8 @@
     real(jprb) :: scat_od, scat_od_cloud
 
+    ! Temporaries to speed up summations
+    real(jprb) :: sum_dn_diff, sum_dn_dir, sum_up
+
+    ! Local cosine of solar zenith angle
     real(jprb) :: mu0
 
@@ -444,13 +447,33 @@
       end if
       
-      ! Store the TOA broadband fluxes
-      flux%sw_up(jcol,1) = sum(sum(flux_up,1))
-      flux%sw_dn(jcol,1) = mu0 * sum(sum(direct_dn,1))
+      ! Store the TOA broadband fluxes, noting that there is no
+      ! diffuse downwelling at TOA. The intrinsic "sum" command has
+      ! been found to be very slow; better performance is found on
+      ! x86-64 architecture with explicit loops and the "omp simd
+      ! reduction" directive.
+      sum_up     = 0.0_jprb
+      sum_dn_dir = 0.0_jprb
+      do jreg = 1,nregions
+        !$omp simd reduction(+:sum_up, sum_dn_dir)
+        do jg = 1,ng
+          sum_up     = sum_up     + flux_up(jg,jreg)
+          sum_dn_dir = sum_dn_dir + direct_dn(jg,jreg)
+        end do
+      end do
+      flux%sw_up(jcol,1) = sum_up
+      flux%sw_dn(jcol,1) = mu0 * sum_dn_dir
       if (allocated(flux%sw_dn_direct)) then
         flux%sw_dn_direct(jcol,1) = flux%sw_dn(jcol,1)
       end if
       if (config%do_clear) then
-        flux%sw_up_clear(jcol,1) = sum(flux_up_clear)
-        flux%sw_dn_clear(jcol,1) = mu0 * sum(direct_dn_clear)
+        sum_up     = 0.0_jprb
+        sum_dn_dir = 0.0_jprb
+        !$omp simd reduction(+:sum_up, sum_dn_dir)
+        do jg = 1,ng
+          sum_up     = sum_up     + flux_up_clear(jg)
+          sum_dn_dir = sum_dn_dir + direct_dn_clear(jg)
+        end do
+        flux%sw_up_clear(jcol,1) = sum_up
+        flux%sw_dn_clear(jcol,1) = mu0 * sum_dn_dir
         if (allocated(flux%sw_dn_direct_clear)) then
           flux%sw_dn_direct_clear(jcol,1) = flux%sw_dn_clear(jcol,1)
@@ -467,6 +490,5 @@
              &           config%i_spec_from_reordered_g_sw, &
              &           flux%sw_dn_band(:,jcol,1))
-        flux%sw_dn_band(:,jcol,1) = &
-             &  mu0 * flux%sw_dn_band(:,jcol,1)
+        flux%sw_dn_band(:,jcol,1) = mu0 * flux%sw_dn_band(:,jcol,1)
         if (allocated(flux%sw_dn_direct_band)) then
           flux%sw_dn_direct_band(:,jcol,1) = flux%sw_dn_band(:,jcol,1)
@@ -549,22 +571,38 @@
                ! nothing to do
 
-        ! Store the broadband fluxes
-        flux%sw_up(jcol,jlev+1) = sum(sum(flux_up,1))
+        ! Store the broadband fluxes. The intrinsic "sum" command has
+        ! been found to be very slow; better performance is found on
+        ! x86-64 architecture with explicit loops and the "omp simd
+        ! reduction" directive.
+        sum_up      = 0.0_jprb
+        sum_dn_dir  = 0.0_jprb
+        sum_dn_diff = 0.0_jprb
+        do jreg = 1,nregions
+          !$omp simd reduction(+:sum_up, sum_dn_diff, sum_dn_dir)
+          do jg = 1,ng
+            sum_up      = sum_up      + flux_up(jg,jreg)
+            sum_dn_diff = sum_dn_diff + flux_dn(jg,jreg)
+            sum_dn_dir  = sum_dn_dir  + direct_dn(jg,jreg)
+          end do
+        end do
+        flux%sw_up(jcol,jlev+1) = sum_up
+        flux%sw_dn(jcol,jlev+1) = mu0 * sum_dn_dir + sum_dn_diff
         if (allocated(flux%sw_dn_direct)) then
-          flux%sw_dn_direct(jcol,jlev+1) = mu0 * sum(sum(direct_dn,1))
-          flux%sw_dn(jcol,jlev+1) &
-               &  = flux%sw_dn_direct(jcol,jlev+1) + sum(sum(flux_dn,1))
-        else
-          flux%sw_dn(jcol,jlev+1) = mu0 * sum(sum(direct_dn,1)) + sum(sum(flux_dn,1))   
+          flux%sw_dn_direct(jcol,jlev+1) = mu0 * sum_dn_dir
         end if
         if (config%do_clear) then
-          flux%sw_up_clear(jcol,jlev+1) = sum(flux_up_clear)
+          sum_up      = 0.0_jprb
+          sum_dn_dir  = 0.0_jprb
+          sum_dn_diff = 0.0_jprb
+          !$omp simd reduction(+:sum_up, sum_dn_diff, sum_dn_dir)
+          do jg = 1,ng
+            sum_up      = sum_up      + flux_up_clear(jg)
+            sum_dn_diff = sum_dn_diff + flux_dn_clear(jg)
+            sum_dn_dir  = sum_dn_dir  + direct_dn_clear(jg)
+          end do
+          flux%sw_up_clear(jcol,jlev+1) = sum_up
+          flux%sw_dn_clear(jcol,jlev+1) = mu0 * sum_dn_dir + sum_dn_diff
           if (allocated(flux%sw_dn_direct_clear)) then
-            flux%sw_dn_direct_clear(jcol,jlev+1) = mu0 * sum(direct_dn_clear)
-            flux%sw_dn_clear(jcol,jlev+1) &
-                 &  = flux%sw_dn_direct_clear(jcol,jlev+1) + sum(flux_dn_clear)
-          else
-            flux%sw_dn_clear(jcol,jlev+1) = mu0 * sum(direct_dn_clear) &
-                 &  + sum(flux_dn_clear)
+            flux%sw_dn_direct_clear(jcol,jlev+1) = mu0 * sum_dn_dir
           end if
         end if
@@ -605,5 +643,4 @@
           end if
         end if
-
       end do ! Final loop over levels
       
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_two_stream.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_two_stream.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_two_stream.F90	(revision 4853)
@@ -22,4 +22,6 @@
 !   2023-09-28  R Hogan  Increased security for single-precision SW "k"
 
+#include "ecrad_config.h"
+
 module radiation_two_stream
 
@@ -43,21 +45,4 @@
 
 contains
-
-#ifdef FAST_EXPONENTIAL
-  !---------------------------------------------------------------------
-  ! Fast exponential for negative arguments: a Pade approximant that
-  ! doesn't go negative for negative arguments, applied to arg/8, and
-  ! the result is then squared three times
-  elemental function exp_fast(arg) result(ex)
-    real(jprd) :: arg, ex
-    ex = 1.0_jprd / (1.0_jprd + arg*(-0.125_jprd &
-         + arg*(0.0078125_jprd - 0.000325520833333333_jprd * arg)))
-    ex = ex*ex
-    ex = ex*ex
-    ex = ex*ex
-  end function exp_fast
-#else
-#define exp_fast exp
-#endif
 
   !---------------------------------------------------------------------
@@ -214,5 +199,5 @@
         k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
              1.0e-12_jprd)) ! Eq 18 of Meador & Weaver (1980)
-        exponential = exp_fast(-k_exponent*od(jg))
+        exponential = exp(-k_exponent*od(jg))
         exponential2 = exponential*exponential
         reftrans_factor = 1.0 / (k_exponent + gamma1(jg) + (k_exponent - gamma1(jg))*exponential2)
@@ -306,6 +291,4 @@
 #endif
 
-! Added for DWD (2020)
-!NEC$ shortloop
     do jg = 1, ng
       factor = (LwDiffusivityWP * 0.5_jprb) * ssa(jg)
@@ -315,5 +298,5 @@
            1.0e-12_jprb)) ! Eq 18 of Meador & Weaver (1980)
       if (od(jg) > 1.0e-3_jprb) then
-        exponential = exp_fast(-k_exponent*od(jg))
+        exponential = exp(-k_exponent*od(jg))
         exponential2 = exponential*exponential
         reftrans_factor = 1.0_jprb / (k_exponent + gamma1 + (k_exponent - gamma1)*exponential2)
@@ -392,8 +375,8 @@
 #endif
 
-    transmittance = exp_fast(-LwDiffusivityWP*od)
-
-! Added for DWD (2020)
-!NEC$ shortloop
+#ifndef DWD_TWO_STREAM_OPTIMIZATIONS
+    transmittance = exp(-LwDiffusivityWP*od)
+#endif
+
     do jg = 1, ng
       ! Compute upward and downward emission assuming the Planck
@@ -401,4 +384,7 @@
       ! (e.g. Wiscombe , JQSRT 1976).
       coeff = LwDiffusivityWP*od(jg)
+#ifdef DWD_TWO_STREAM_OPTIMIZATIONS
+      transmittance(jg) = exp(-coeff)
+#endif
       if (od(jg) > 1.0e-3_jprb) then
         ! Simplified from calc_reflectance_transmittance_lw above
@@ -516,7 +502,7 @@
         k_gamma4 = k_exponent*gamma4
         ! Check for mu0 <= 0!
-        exponential0 = exp_fast(-od_over_mu0)
+        exponential0 = exp(-od_over_mu0)
         trans_dir_dir(jg) = exponential0
-        exponential = exp_fast(-k_exponent*od(jg))
+        exponential = exp(-k_exponent*od(jg))
         
         exponential2 = exponential*exponential
@@ -609,7 +595,13 @@
     ! The three transfer coefficients from the two-stream
     ! differentiatial equations 
+#ifndef DWD_TWO_STREAM_OPTIMIZATIONS
     real(jprb), dimension(ng) :: gamma1, gamma2, gamma3, gamma4 
     real(jprb), dimension(ng) :: alpha1, alpha2, k_exponent
     real(jprb), dimension(ng) :: exponential ! = exp(-k_exponent*od)
+#else
+    real(jprb) :: gamma1, gamma2, gamma3, gamma4 
+    real(jprb) :: alpha1, alpha2, k_exponent
+    real(jprb) :: exponential ! = exp(-k_exponent*od)
+#endif
     
     real(jprb) :: reftrans_factor, factor
@@ -625,12 +617,11 @@
 #endif
 
+#ifndef DWD_TWO_STREAM_OPTIMIZATIONS
     ! GCC 9.3 strange error: intermediate values of ~ -8000 cause a
     ! FPE when vectorizing exp(), but not in non-vectorized loop, nor
     ! with larger negative values!
     trans_dir_dir = max(-max(od * (1.0_jprb/mu0), 0.0_jprb),-1000.0_jprb)
-    trans_dir_dir = exp_fast(trans_dir_dir)
-
-! Added for DWD (2020)
-!NEC$ shortloop
+    trans_dir_dir = exp(trans_dir_dir)
+
     do jg = 1, ng
 
@@ -659,7 +650,6 @@
     end do
 
-    exponential = exp_fast(-k_exponent*od)
-
-!NEC$ shortloop
+    exponential = exp(-k_exponent*od)
+
     do jg = 1, ng
       k_mu0 = k_exponent(jg)*mu0
@@ -705,5 +695,74 @@
       trans_dir_diff(jg) = max(0.0_jprb, min(trans_dir_diff(jg), mu0*(1.0_jprb-trans_dir_dir(jg))-ref_dir(jg)))
     end do
-    
+
+#else
+    ! GPU-capable and vector-optimized version for ICON
+    do jg = 1, ng
+
+      trans_dir_dir(jg) = max(-max(od(jg) * (1.0_jprb/mu0),0.0_jprb),-1000.0_jprb)
+      trans_dir_dir(jg) = exp(trans_dir_dir(jg))
+
+      ! Zdunkowski "PIFM" (Zdunkowski et al., 1980; Contributions to
+      ! Atmospheric Physics 53, 147-66)
+      factor = 0.75_jprb*asymmetry(jg)
+
+      gamma1 = 2.0_jprb  - ssa(jg) * (1.25_jprb + factor)
+      gamma2 = ssa(jg) * (0.75_jprb - factor)
+      gamma3 = 0.5_jprb  - mu0*factor
+      gamma4 = 1.0_jprb - gamma3
+
+      alpha1 = gamma1*gamma4 + gamma2*gamma3 ! Eq. 16
+      alpha2 = gamma1*gamma3 + gamma2*gamma4 ! Eq. 17
+#ifdef PARKIND1_SINGLE
+      k_exponent = sqrt(max((gamma1 - gamma2) * (gamma1 + gamma2), 1.0e-6_jprb))  ! Eq 18
+#else
+      k_exponent = sqrt(max((gamma1 - gamma2) * (gamma1 + gamma2), 1.0e-12_jprb)) ! Eq 18
+#endif
+
+      exponential = exp(-k_exponent*od(jg))
+
+      k_mu0 = k_exponent*mu0
+      one_minus_kmu0_sqr = 1.0_jprb - k_mu0*k_mu0
+      k_gamma3 = k_exponent*gamma3
+      k_gamma4 = k_exponent*gamma4
+      exponential2 = exponential*exponential
+      k_2_exponential = 2.0_jprb * k_exponent * exponential
+      reftrans_factor = 1.0_jprb / (k_exponent + gamma1 + (k_exponent - gamma1)*exponential2)
+        
+      ! Meador & Weaver (1980) Eq. 25
+      ref_diff(jg) = gamma2 * (1.0_jprb - exponential2) * reftrans_factor
+        
+      ! Meador & Weaver (1980) Eq. 26
+      trans_diff(jg) = k_2_exponential * reftrans_factor
+        
+      ! Here we need mu0 even though it wasn't in Meador and Weaver
+      ! because we are assuming the incoming direct flux is defined to
+      ! be the flux into a plane perpendicular to the direction of the
+      ! sun, not into a horizontal plane
+      reftrans_factor = mu0 * ssa(jg) * reftrans_factor &
+            &  / merge(one_minus_kmu0_sqr, epsilon(1.0_jprb), abs(one_minus_kmu0_sqr) > epsilon(1.0_jprb))
+      
+      ! Meador & Weaver (1980) Eq. 14, multiplying top & bottom by
+      ! exp(-k_exponent*od) in case of very high optical depths
+      ref_dir(jg) = reftrans_factor &
+           &  * ( (1.0_jprb - k_mu0) * (alpha2 + k_gamma3) &
+           &     -(1.0_jprb + k_mu0) * (alpha2 - k_gamma3)*exponential2 &
+           &     -k_2_exponential*(gamma3 - alpha2*mu0)*trans_dir_dir(jg) )
+        
+      ! Meador & Weaver (1980) Eq. 15, multiplying top & bottom by
+      ! exp(-k_exponent*od), minus the 1*exp(-od/mu0) term
+      ! representing direct unscattered transmittance.
+      trans_dir_diff(jg) = reftrans_factor * ( k_2_exponential*(gamma4 + alpha1*mu0) &
+           & - trans_dir_dir(jg) &
+           & * ( (1.0_jprb + k_mu0) * (alpha1 + k_gamma4) &
+           &    -(1.0_jprb - k_mu0) * (alpha1 - k_gamma4) * exponential2) )
+
+      ! Final check that ref_dir + trans_dir_diff <= 1
+      ref_dir(jg)        = max(0.0_jprb, min(ref_dir(jg), mu0*(1.0_jprb-trans_dir_dir(jg))))
+      trans_dir_diff(jg) = max(0.0_jprb, min(trans_dir_diff(jg), mu0*(1.0_jprb-trans_dir_dir(jg))-ref_dir(jg)))
+
+    end do
+#endif
+
 #ifdef DO_DR_HOOK_TWO_STREAM
     if (lhook) call dr_hook('radiation_two_stream:calc_ref_trans_sw',1,hook_handle)
@@ -757,5 +816,5 @@
       k_exponent = sqrt(max((gamma1(jg) - gamma2(jg)) * (gamma1(jg) + gamma2(jg)), &
            &       1.0e-12_jprd)) ! Eq 18
-      exponential = exp_fast(-k_exponent*od(jg))
+      exponential = exp(-k_exponent*od(jg))
       exponential2 = exponential*exponential
       k_2_exponential = 2.0_jprd * k_exponent * exponential
@@ -766,8 +825,8 @@
       ! Until 1.1.8, used LwDiffusivity instead of 2.0, although the
       ! effect is very small
-      !      frac_scat_diffuse(jg) = 1.0_jprb - min(1.0_jprb,exp_fast(-LwDiffusivity*od(jg)) &
+      !      frac_scat_diffuse(jg) = 1.0_jprb - min(1.0_jprb,exp(-LwDiffusivity*od(jg)) &
       !           &  / max(1.0e-8_jprb, k_2_exponential * reftrans_factor))
       frac_scat_diffuse(jg) = 1.0_jprb &
-           &  - min(1.0_jprb,exp_fast(-2.0_jprb*od(jg)) &
+           &  - min(1.0_jprb,exp(-2.0_jprb*od(jg)) &
            &  / max(1.0e-8_jprb, k_2_exponential * reftrans_factor))
     end do
Index: /LMDZ6/trunk/libf/phylmd/ecrad/test/ifs/Makefile
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/test/ifs/Makefile	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/test/ifs/Makefile	(revision 4853)
@@ -15,4 +15,5 @@
 CONFIG = configCY49R1.nam
 CONFIG_ECCKD = configCY49R1_ecckd.nam
+CONFIG_MIXED = configCY49R1_mixed.nam
 
 # Typing "make" will run radiation scheme on IFS profiles
@@ -111,4 +112,13 @@
 test_ecckd_tc:
 	$(DRIVER) $(CONFIG_ECCKD) $(INPUT).nc $(INPUT)_ecckd_tc_out.nc
+
+test_mixed_gas:
+	$(DRIVER) $(CONFIG_MIXED) $(INPUT).nc $(INPUT)_sw_ecckd_lw_ecckd_out.nc
+	$(CHANGENAM) $(CONFIG_MIXED) config_mix.nam lw_gas_model_name='"RRTMG-IFS"' do_cloud_aerosol_per_lw_g_point=false
+	$(DRIVER) config_mix.nam $(INPUT).nc $(INPUT)_sw_ecckd_lw_rrtmg_out.nc
+	$(CHANGENAM) $(CONFIG_MIXED) config_mix.nam sw_gas_model_name='"RRTMG-IFS"' do_cloud_aerosol_per_sw_g_point=false
+	$(DRIVER) config_mix.nam $(INPUT).nc $(INPUT)_sw_rrtmg_lw_ecckd_out.nc
+	$(CHANGENAM) $(CONFIG_MIXED) config_mix.nam sw_gas_model_name='"RRTMG-IFS"' lw_gas_model_name='"RRTMG-IFS"' do_cloud_aerosol_per_lw_g_point=false do_cloud_aerosol_per_sw_g_point=false
+	$(DRIVER) config_mix.nam $(INPUT).nc $(INPUT)_sw_rrtmg_lw_rrtmg_out.nc
 
 # ecCKD with no aerosols
Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4853)
@@ -4364,7 +4364,5 @@
                   flag_aerosol, flag_bc_internal_mixture, itap, jD_cur-jD_ref, &
                   pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-                  tr_seri, mass_solu_aero, mass_solu_aero_pi,  &
-                  tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,  &
-                  tausum_aero, drytausum_aero, tau3d_aero)
+                  tr_seri, mass_solu_aero, mass_solu_aero_pi)  
 #else
                 abort_message='You should compile with -rad ecrad if running with iflag_rrtm=2'
Index: /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90	(revision 4853)
@@ -1354,5 +1354,8 @@
       endif
 ! lldebug_for_offline
- 
+
+  if (namelist_ecrad_file.eq.'namelist_ecrad') then 
+      print*,' 1er apell Ecrad : ok_3Deffect, namelist_ecrad_file = ', &
+          ok_3Deffect, namelist_ecrad_file    
       CALL RADIATION_SCHEME &
       & (ist, iend, klon, klev, naero_grp, NSW, &
@@ -1396,4 +1399,50 @@
       & PSFSWDIF, PSFSWDIR, &
       & cloud_cover_sw)
+  else
+   print*,' 2e apell Ecrad : ok_3Deffect, namelist_ecrad_file = ', &
+          ok_3Deffect, namelist_ecrad_file       
+   CALL RADIATION_SCHEME_S2 &
+      & (ist, iend, klon, klev, naero_grp, NSW, &
+      & namelist_ecrad_file, ok_3Deffect, &
+      & debut, ok_volcan, flag_aerosol_strat, &
+      & day_cur, current_time, &
+!       Cste solaire/(d_Terre-Soleil)**2
+      & SOLARIRAD, &
+!       Cos(angle zin), temp sol              
+      & rmu0, tsol, &
+!       Albedo diffuse et directe
+      & PALBD_NEW,PALBP_NEW, &
+!       Emessivite : PEMIS_WINDOW (???), &
+      & ZEMIS, ZEMISW, &
+!       longitude(rad), sin(latitude), PMASQ_ ???
+      & ZGELAM, ZGEMU, &
+!       Temp et pres aux interf, vapeur eau, Satur spec humid 
+      & paprs_i, ZTH_i, q_i, qsat_i, & 
+!       Gas
+       & ZCO2, ZCH4, ZN2O, ZNO2, ZCFC11, ZCFC12, ZHCFC22, &
+       & ZCCL4, POZON_i(:,:,1), ZO2, &
+!       nuages :
+      & cldfra_i, flwc_i, fiwc_i, ZQ_SNOW, &
+!       rayons effectifs des gouttelettes              
+      & ref_liq_i, ref_ice_i, &
+!       aerosols
+     & ZAEROSOL_OLD, ZAEROSOL, &
+! Outputs
+!       Net flux :
+      & ZSWFT_i, ZLWFT_i, ZSWFT0_ii, ZLWFT0_ii, &
+!       DWN flux :
+      & ZFSDWN_i, ZFLUX_i(:,2,:), ZFCDWN_i, ZFLUC_i(:,2,:), &
+!       UP flux :
+      & ZFSUP_i, ZFLUX_i(:,1,:), ZFCUP_i, ZFLUC_i(:,1,:), &
+!       Surf Direct flux : ATTENTION
+      & ZFLUX_DIR, ZFLUX_DIR_CLEAR, ZFLUX_DIR_INTO_SUN, &
+!       UV and para flux
+      & ZFLUX_UV, ZFLUX_PAR, ZFLUX_PAR_CLEAR, &
+!      & ZFLUX_SW_DN_TOA,
+      & ZEMIS_OUT, ZLWDERIVATIVE, &
+      & PSFSWDIF, PSFSWDIR, &
+      & cloud_cover_sw)
+  endif
+
 
       print *,'========= RADLWSW: apres RADIATION_SCHEME ==================== '
